import { Observable, Observer, Subject, Subscriber, Unsubscribable } from "rxjs";
import dotenv from 'dotenv';
import { AdaptorTransmissionRole, ConnectionAdaptorBase, ConnectionState } from "../interface/connector.interface";
import { Bus, FisAppActor, FisMessage } from "../interface/transport.interface";

dotenv.config();
/* This transport manager will be instantiating the necessary transport to deal with tranmission and receiving from different receivers
So how?: */
export class ConnectionAdapter implements FisAppActor, ConnectionAdaptorBase {
    incomingMessageBus: Subject<any> = new Subject()
    outgoingMessageBus: Subject<any> = new Subject()
    connector: any;
    connectorProfile: any;
    connectionState!: ConnectionState;
    connectionStateBus!: Observable<ConnectionState>;
    adaptorTransmissionRole!: AdaptorTransmissionRole;

    constructor(port?: number, url?: string) {
        if (!port && !url) console.error(`No role has assigned for transport service due to lack of information provided!`)
    }

    getMessageBus(bus: Bus): Observable<any> {
        throw new Error("Method not implemented.");
    }

    subscribeConnectionState(): Observable<ConnectionState> {
        throw new Error("Method not implemented.");
    }
    publishConnectionState(): void {
        throw new Error("Method not implemented.");
    }
    connect(): void {
        throw new Error("Method not implemented.");
    }
    disconnect(): void {
        throw new Error("Method not implemented.");
    }
    send(message: any): Observable<any> {
        throw new Error(`Method not implemented.`)
    }
    emit(message: any): void {
        // logic here
    }
    emitStream(message: any): void {
        throw new Error("Method not implemented.");
    }
    subscribeMessages(messageFilter: any): Observable<any> {
        throw new Error("Method not implemented.");
    }
    subscribe(subscriber: Subscriber<any>): Unsubscribable {
        throw new Error("Method not implemented.");
    }



}


