
import { filter, Observable, Observer, Subject, Subscription, takeWhile, Unsubscribable } from 'rxjs';
import { AdaptorTransmissionRole } from '../interface/connector.interface';
import { Bus, FisMessage, MessageTransmissionBase as MessageTransmissionBaseInterface } from '../interface/transport.interface'
import { v4 as uuidv4 } from 'uuid'

export class MessageTransmissionBase implements MessageTransmissionBaseInterface {
    msgRepositoryService: any;
    transmissionRole!: AdaptorTransmissionRole;
    adaptorsArray!: any[];
    transmissionService: any;
    adapterService: any;
    incomingMessageBus!: Subject<any>;
    outgoingMessageBus!: Subject<any>;

    constructor() {
        // logic here
    }

    getMessageBus(bus: Bus): Observable<any> {
        throw new Error('Method not implemented.');
    }

    send(message: any): Observable<any> {
        throw new Error(`Method not implemented.`)
    }

    subscribe(observer: Partial<Observer<any>>): Unsubscribable {
        throw new Error('Method not implemented.');
    }
    emit(message: any): void {
        throw new Error('Method not implemented.');
    }
    emitStream(message: any): void {
        throw new Error('Method not implemented.');
    }
    subscribeMessages(messageFilter: any): Observable<any> {
        throw new Error('Method not implemented.');
    }

}