import { PartialObserver, Subject, Subscriber, Unsubscribable } from 'rxjs';
import { AdaptorTransmissionRole } from '../interface/connector.interface';
import { MessageTransmissionBase } from './msg.transmission.base';
import { MessageReceiver as MessageReceiverInterface, ReceiverProfile, TransmitterProfile } from '../interface/transport.interface'
import { ConnectionAdapter } from '../connector/connector.base';
import { v4 as uuidv4 } from 'uuid'
import { ReceiverConnectionAdapter } from '../connector/connector.receiver';

export class MessageTransmissionReceiver extends MessageTransmissionBase implements MessageReceiverInterface {
    receiverProfile!: ReceiverProfile;

    constructor(profile: ReceiverProfile, role: AdaptorTransmissionRole, adapter: ReceiverConnectionAdapter) {
        super();
        this.setReceiver(profile, role, adapter)
    }

    setReceiver(receiverProfile: ReceiverProfile, role: AdaptorTransmissionRole, adapter: ReceiverConnectionAdapter): void {
        this.receiverProfile = receiverProfile
        this.transmissionRole = role
        this.adapterService = adapter
    }

    private instantiateConnectionAdapter(): void {
        // logic here
    }
}
