import { MessageTransmissionBase } from "./msg.transmission.base";
import { FisMessage,  MessageTransmitter as MessageTransmitterInterface, TransmitterProfile } from '../interface/transport.interface'
import { AdaptorTransmissionRole } from "../interface/connector.interface";
import { v4 as uuidv4 } from 'uuid'
import { TransmitterConnectionAdapter } from "../connector/connector.transmitter";

export class MessageTransmissionTransmitter extends MessageTransmissionBase implements MessageTransmitterInterface {
    transmitterProfile!: TransmitterProfile;

    constructor(profile: TransmitterProfile, role: AdaptorTransmissionRole, adapter: TransmitterConnectionAdapter) {
        super()
        this.setTransmitter(profile, role, adapter)
    }
    
    setTransmitter(transmitterProfile: TransmitterProfile, role: AdaptorTransmissionRole, adapter: TransmitterConnectionAdapter): void {
        this.transmitterProfile = transmitterProfile
        this.transmissionRole = role
        this.adapterService = adapter
    }

    emit(message: FisMessage): void {
        throw new Error(`Method not implemented`)
    }

    getTransmitterInfo(): TransmitterProfile {
        return this.transmitterProfile
    }
}